# Copyright (C) 2006-2009 Simula Research Laboratory and Johan Hake
# Licensed under the GNU GPL Version 3.0.

#!/usr/bin/env python
"""This script demostrates the use of the tetgen python wrapper tetbuilder."""
#import mpi
from tritetmesh.tetmesh import *
import numpy

# Peacewise Liner Complex,
plceditor = PLCEditor()

# plceditor can take any sequence of numbers in python, e.g. lists, tuples and numpy arrays.

# Add the coordinates for the vertices
x = [0,1,0,1,0,1,0,1,0.25,0.75,0.25,0.75,0.25,0.75,
                 0.25,0.75,1,1,1,1,0.875,0.875,0.875,0.875,0,0,0,0]

y = (0,0,1,1,0,0,1,1,0.25,0.25,0.75,0.75,0.25,0.25,
                 0.75,0.75,0.25,0.75,0.25,0.75,0.25,0.75,0.25,0.75,0.25,0.75,0.25,0.75)

z = numpy.array([0,0,0,0,1,1,1,1,0.25,0.25,0.25,0.25,0.75,0.75,
                 0.75,0.75,0.25,0.25,0.75,0.75,0.25,0.25,0.75,0.75,0.25,0.25,0.75,0.75],'d')

plceditor.register_vertices(x,y,z)

# Add vertex markers
plceditor.add_vertex_marker(10,[0,1,2,3])
plceditor.add_vertex_marker(20,[4,5,6,7])

# Facet with marker
plceditor.add_facet([0,1,3,2],1)

# Facet with marker and area constraint
plceditor.add_facet([4,5,7,6],2,0.001)

# Facet with marker and a hole
plceditor.add_facet([0,2,6,4],3)
plceditor.add_polygon_to_last_facet([24,25,27,26],[0,0.5,0.5])

# Facet with marker and area constraint
plceditor.add_facet([24,25,27,26],7,0.001)

# Facet with marker and a hole
plceditor.add_facet([1,3,7,5],4)
plceditor.add_polygon_to_last_facet([16,17,19,18],[1,0.5,0.5])

# Add internal facets
plceditor.add_facet([20,21,23,22])
plceditor.add_facet([16,18,22,20])
plceditor.add_facet([18,19,23,22])
plceditor.add_facet([17,19,23,21])
plceditor.add_facet([16,17,21,20])

# Facet with marker
plceditor.add_facet([0,1,5,4],5)

# Facet with marker
plceditor.add_facet([2,3,7,6],6)

# Add internal facets
plceditor.add_facet([8,9,11,10])
plceditor.add_facet([12,13,15,14])
plceditor.add_facet([8,10,14,12])
plceditor.add_facet([9,11,15,13])
plceditor.add_facet([8,9,13,12])
plceditor.add_facet([10,11,15,14])
plceditor.add_facet([0,2,10,8])
plceditor.add_facet([0,1,9,8])
plceditor.add_facet([1,3,11,9])
plceditor.add_facet([2,3,11,10])

# Add a hole and a region
plceditor.add_hole([0.5,0.5,0.5])
plceditor.add_region([0.5,0.5,0.125], 5, 0.0001)

# Build the plc and close the editor
plceditor.build('result',True)

# FIXME: Removed functionality consider including it in the interface

# Test for intersecting facets
#plc.test()
#
## Build the tetmesh
#plc.build_mesh(tetmesh)
#
## Save the result in different formats
#plc.save_tetgen("plc")
#tetmesh.save_tetgen("result")
#tetmesh.save_dolfin("result")
#
#tetmesh_from_dolfin = TetMesh()
#
#refined = TetMesh()
#tetmesh_from_dolfin.refine_mesh(tetmesh,"rq1.1")
#
#tetmesh.save_tetgen("refined")
