#import mpi
from tritetmesh.tetmesh import *
from numpy import *

# Cylinder parameters
num_arc_points = 32
radius = 1
hight = 1

# Start point
x0, y0, z0 = 0., 0., 0.

# Angle array
theta = arange(num_arc_points, dtype='d')/num_arc_points*2*pi

# Coordinates
x = radius*cos(theta) + x0
x = concatenate((x, x))

y = radius*sin(theta) + y0
y = concatenate((y, y))

z = array([z0]*num_arc_points + [z0+hight]*num_arc_points)

# Create the PLC Editor
editor = PLCEditor()

editor.register_vertices(x, y, z)

# Add bottom facet with marker 1
editor.add_facet(range(num_arc_points), 1)

# Add topp facet with marker 2
editor.add_facet(range(num_arc_points, num_arc_points*2), 2)

# Add collar facets
for facet in rectangle_collar(32):
    editor.add_facet(facet)

# Build and save mesh
editor.build("result")
