// Copyright (C) 2006-2009 Simula Research Laboratory and Johan Hake
// Licensed under the GNU GPL Version 3.0.

#include <cstdlib>
#include <vector>
#include <math.h>

#include <tritetmesh/trimesh/pslgeditor.h>

using namespace std;
using namespace tritetmesh;

#define PI 3.14159

int main(int argc, char *argv[])
{
  // The area function defining the maximal area in the domain
  class MyAreaFunc : public AreaFunction
  {
  public:
    
    MyAreaFunc() : AreaFunction() {}
    
    double eval(double x, double y)
    {
      return fabs(sin(PI*x) + sin(PI*y))/10 + 0.00000001;
    }
    
  };
  
  PSLGEditor editor;
  
  MyAreaFunc area_func;

  // Coordinates for the vertices and values of the interpolated field
  vector<double> xv, yv, f1, f2;
  
  xv.push_back(0.0); xv.push_back(0.0); xv.push_back(4.0); xv.push_back(4.0);
  yv.push_back(0.0); yv.push_back(4.0); yv.push_back(4.0); yv.push_back(0.0);
  
  f1.push_back(1.0); f1.push_back(1.0); f1.push_back(0.0); f1.push_back(0.0);
  f2.push_back(0.0); f2.push_back(0.0); f2.push_back(1.0); f2.push_back(1.0);
  
  vector<unsigned int> p1;
  p1.push_back(0);p1.push_back(1); p1.push_back(2); p1.push_back(3);
  
  editor.register_vertices(xv,yv,f1,f2);
  editor.add_polygon(p1,2, 0.1);
  editor.add_area_function(area_func);
  editor.set_minimum_angle(30);
  editor.build("result",true);

  std::exit(0);
  }
