# Copyright (C) 2006-2009 Simula Research Laboratory and Johan Hake
# Licensed under the GNU GPL Version 3.0.

#import mpi
from tritetmesh.trimesh import *
from math import sin, pi, cos

class MyAreaFunc(AreaFunction):
    def eval(self, x, y):
        return (abs(sin(pi*x) + cos(pi*y)))/10 + 0.00000001

area_func = MyAreaFunc()

editor = PSLGEditor()

editor.register_vertices([0,0,4,4],[0,4,4,0],[4,4,0,0],[0,0,4,4])
editor.add_polygon([0,1,2,3],2, 0.1)
editor.add_area_function(area_func)
editor.set_minimum_angle(30)
editor.build('result',True)

