# Copyright (C) 2006-2009 Simula Research Laboratory and Johan Hake
# Licensed under the GNU GPL Version 3.0.

#import mpi
from tritetmesh.trimesh import *
from numpy import *
editor = PSLGEditor()

for refinement in xrange(7):
  print ''
  print 'Refinemet level is' , refinement
  print ''
  editor.clear()

  ds = 0.01 / (refinement+1.0)
  R = 0.05
  width = 2.2
  height = 0.41

  region_width = .7
  region_height = 0.2
  region_x_offset = 0.1
  region_y_offset = 0.1

  rect_area_constraint = ds/10
  region_rect_area_constraint = ds/50

  circle_x_position = 0.2
  circle_y_position = 0.2

  dtheta = ds/R
  theta_range = 2*pi/dtheta
  new_dtheta = 2*pi/floor(theta_range)
  print 'dtheta', dtheta
  print 'new_dtheta', new_dtheta
  theta = arange(0,2*pi,new_dtheta)
  print 'theta', theta

  xcoord_rect = array([0,0,1,1])*width
  ycoord_rect = array([0,1,1,0])*height


  xcoord_rect_region = array([0,0,1,1])*region_width  + circle_x_position - region_x_offset
  ycoord_rect_region = array([0,1,1,0])*region_height + circle_y_position - region_y_offset


  xcoord_circ = R*cos(theta)+circle_x_position#*width
  ycoord_circ = R*sin(theta)+circle_y_position#*height

  num_circ_points = len(ycoord_circ)

  assert R < region_x_offset
  assert R < region_y_offset

  editor.register_vertices(concatenate((xcoord_rect,xcoord_rect_region,xcoord_circ)),\
			  concatenate((ycoord_rect,ycoord_rect_region,ycoord_circ)))


  # Add rectangle
  editor.add_polygon(range(4))
  editor.add_polygon(range(4,8))


  print region_rect_area_constraint, rect_area_constraint
  print ds
  print (circle_x_position-R-ds ,circle_y_position)


  circle_poly = arange(num_circ_points,dtype="i")+len(xcoord_rect)+len(xcoord_rect_region)
  editor.add_polygon(circle_poly)

  editor.add_hole([circle_x_position,circle_y_position])
  editor.add_region([ds,ds],1,rect_area_constraint)
  editor.add_region([circle_x_position-R-ds ,circle_y_position], 1, region_rect_area_constraint)

  editor.set_minimum_angle(30)
  editor.build('result_'+'refinement_'+str(refinement))
